"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RruFormElement = exports.RruForm = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactHookForm = _interopRequireWildcard(require("react-hook-form"));

var _reactSelect = _interopRequireDefault(require("react-select"));

require("./style.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * @author coder966
 */
var RruForm = function RruForm(_ref) {
  var initialValues = _ref.initialValues,
      validationSchema = _ref.validationSchema,
      onSubmit = _ref.onSubmit,
      watch = _ref.watch,
      watcher = _ref.watcher,
      children = _ref.children,
      className = _ref.className;

  // transform initialValues object to meet our requirements:
  // 1- grouped-multi-checkbox and multi-checkbox elements needs initial value array to have string items not integers
  if (initialValues) {
    for (var _i = 0, _Object$entries = Object.entries(initialValues); _i < _Object$entries.length; _i++) {
      var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2),
          key = _Object$entries$_i[0],
          value = _Object$entries$_i[1];

      if (value && Array.isArray(value)) {
        initialValues[key] = value.map(function (item) {
          return item + '';
        });
      }
    }
  }

  var form = (0, _reactHookForm.default)({
    mode: 'onChange',
    defaultValues: initialValues,
    validationSchema: validationSchema
  });

  if (watch) {
    if (Array.isArray(watch) && watcher) {
      watcher(form.watch(watch));
    } else {
      // TODO: remove deprecated
      watch(form.watch);
    }
  }

  return /*#__PURE__*/_react.default.createElement(_reactHookForm.FormContext, form, /*#__PURE__*/_react.default.createElement("form", {
    className: className,
    onSubmit: form.handleSubmit(onSubmit)
  }, children));
};
/**
 * @author coder966
 * acceptable types: text (default), password, textarea, select, radio, checkbox, multi-checkbox, grouped-multi-checkbox, date, time, file
 */


exports.RruForm = RruForm;

var RruFormElement = function RruFormElement(props) {
  var name = props.name,
      type = props.type,
      label = props.label,
      options = props.options,
      disabled = props.disabled,
      prepend = props.prepend,
      append = props.append;

  var _useState = (0, _react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      initialSelectOption = _useState2[0],
      setInitialSelectOption = _useState2[1];

  var formContext = (0, _reactHookForm.useFormContext)();
  var sharedProps = {
    ref: formContext.register,
    id: name,
    name: name,
    disabled: disabled,
    placeholder: props.placeholder,
    maxLength: props.maxLength
  };

  if (type === 'date' || type === 'time' || type === 'select') {
    formContext.register({
      name: name
    });
  } // because controlled fields need to call setValue for the initial value
  // this issue is also present in date and time be is handled in the DatePicker constructor


  (0, _react.useEffect)(function () {
    if (type === 'select') {
      // determine the initial option
      var option;

      if (props.defaultValue) {
        var defaultOption = options.find(function (o) {
          return o.id + '' === props.defaultValue + '';
        });

        if (defaultOption) {
          option = defaultOption;
        } else {
          option = options[0];
        }
      } else {
        option = options[0];
      } // transform it to react-select schema and set form value


      setInitialSelectOption({
        value: option.id,
        label: option.label
      });
      formContext.setValue(name, option.id);
    }
  }, []);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: props.className ? props.className : 'form-group'
  }, label && type !== 'checkbox' ? /*#__PURE__*/_react.default.createElement("div", {
    className: (props.labelClassName ? props.labelClassName : 'mr-1 ml-1') + ' row'
  }, /*#__PURE__*/_react.default.createElement("label", {
    className: "custom-label",
    htmlFor: name
  }, label)) : null, /*#__PURE__*/_react.default.createElement("div", {
    className: (props.inputClassName ? props.inputClassName : label ? 'mr-1 ml-1' : '') + ' row'
  }, !type || type === 'text' || type === 'password' ? /*#__PURE__*/_react.default.createElement("div", {
    className: "input-group"
  }, prepend ? /*#__PURE__*/_react.default.createElement("div", {
    className: "input-group-prepend"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "input-group-text"
  }, prepend)) : null, /*#__PURE__*/_react.default.createElement("input", _extends({}, sharedProps, {
    type: type,
    className: 'form-control ' + (formContext.errors[name] ? 'is-invalid' : null)
  })), append ? /*#__PURE__*/_react.default.createElement("div", {
    className: "input-group-prepend"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "input-group-text"
  }, append)) : null) : type === 'textarea' ? /*#__PURE__*/_react.default.createElement("textarea", _extends({}, sharedProps, {
    className: 'form-control ' + (formContext.errors[name] ? 'is-invalid' : null)
  })) : type === 'select' ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, initialSelectOption ? /*#__PURE__*/_react.default.createElement(_reactSelect.default, {
    name: name,
    disabled: disabled,
    defaultValue: initialSelectOption,
    onChange: function onChange(option) {
      return formContext.setValue(name, option.value);
    },
    options: options.map(function (o) {
      return {
        value: o.id,
        label: o.label
      };
    }),
    styles: {
      container: function container(provided, state) {
        return _objectSpread(_objectSpread({}, provided), {}, {
          width: '100%'
        });
      }
    }
  }) : null) : type === 'radio' ? /*#__PURE__*/_react.default.createElement("div", {
    className: props.inline ? 'form-check-inline' : null
  }, options.map(function (o) {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: "".concat(name, "_").concat(o.id),
      className: 'form-check' + disabled ? ' disabled' : null
    }, /*#__PURE__*/_react.default.createElement("input", _extends({
      type: "radio"
    }, sharedProps, {
      value: o.id,
      id: o.id
    })), /*#__PURE__*/_react.default.createElement("label", {
      className: "form-check-label",
      htmlFor: o.id
    }, o.label));
  })) : type === 'checkbox' ? /*#__PURE__*/_react.default.createElement("div", {
    className: "custom-control custom-checkbox m-1"
  }, /*#__PURE__*/_react.default.createElement("input", {
    id: name,
    name: name,
    ref: formContext.register,
    type: "checkbox",
    className: 'custom-control-input ' + (formContext.errors[name] ? 'is-invalid' : ''),
    disabled: disabled
  }), /*#__PURE__*/_react.default.createElement("label", {
    htmlFor: name,
    className: "custom-control-label"
  }, label)) : type === 'multi-checkbox' ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("input", {
    id: "".concat(name, "_hidden1"),
    name: name,
    ref: formContext.register,
    value: 'hidden1',
    type: "checkbox",
    disabled: true,
    style: {
      display: 'none'
    }
  }), /*#__PURE__*/_react.default.createElement("input", {
    id: "".concat(name, "_hidden2"),
    name: name,
    ref: formContext.register,
    value: 'hidden2',
    type: "checkbox",
    disabled: true,
    style: {
      display: 'none'
    }
  }), options.map(function (o) {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: "".concat(name, "_").concat(o.id),
      className: "col-12 col-sm-6 col-md-4 col-lg-3 col-xl-3"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "custom-control custom-checkbox m-1"
    }, /*#__PURE__*/_react.default.createElement("input", {
      id: "".concat(name, "_").concat(o.id),
      name: name,
      ref: formContext.register,
      value: o.id,
      type: "checkbox",
      className: "custom-control-input",
      disabled: disabled
    }), /*#__PURE__*/_react.default.createElement("label", {
      htmlFor: "".concat(name, "_").concat(o.id),
      className: "custom-control-label"
    }, o.label)));
  })) : type === 'grouped-multi-checkbox' ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("input", {
    id: "".concat(name, "_hidden1"),
    name: name,
    ref: formContext.register,
    value: 'hidden1',
    type: "checkbox",
    disabled: true,
    style: {
      display: 'none'
    }
  }), /*#__PURE__*/_react.default.createElement("input", {
    id: "".concat(name, "_hidden2"),
    name: name,
    ref: formContext.register,
    value: 'hidden2',
    type: "checkbox",
    disabled: true,
    style: {
      display: 'none'
    }
  }), options.map(function (g, i) {
    return /*#__PURE__*/_react.default.createElement(_react.Fragment, {
      key: "".concat(name, "_g").concat(i)
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "grouped-multi-checkbox-group-header"
    }, g.label), /*#__PURE__*/_react.default.createElement("div", {
      className: "grouped-multi-checkbox-group-row row col"
    }, g.items.map(function (o) {
      return /*#__PURE__*/_react.default.createElement("div", {
        key: "".concat(name, "_").concat(o.id),
        className: "col-12 col-sm-6 col-md-4 col-lg-3 col-xl-3"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "custom-control custom-checkbox m-1"
      }, /*#__PURE__*/_react.default.createElement("input", {
        id: "".concat(name, "_").concat(o.id),
        name: name,
        ref: formContext.register,
        value: o.id,
        type: "checkbox",
        className: "custom-control-input",
        disabled: disabled
      }), /*#__PURE__*/_react.default.createElement("label", {
        htmlFor: "".concat(name, "_").concat(o.id),
        className: "custom-control-label"
      }, o.label)));
    })));
  })) : type === 'date' || type === 'time' ? /*#__PURE__*/_react.default.createElement("div", {
    className: "input-group"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "input-group-prepend"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: 'input-group-text ' + (type === 'date' ? 'fa fa-calendar-alt' : 'fas fa-clock')
  })), /*#__PURE__*/_react.default.createElement(DatePicker, {
    type: type,
    onChange: function onChange(value) {
      return formContext.setValue(name, value);
    },
    defaultValue: props.defaultValue,
    reverseDisplayOrder: props.reverseDisplayOrder,
    isHijri: props.isHijri,
    isFuture: props.isFuture,
    isPast: props.isPast,
    clock: props.clock,
    maxYearLength: props.maxYearLength,
    disabled: disabled
  })) : type === 'file' ? /*#__PURE__*/_react.default.createElement("div", {
    className: "input-group"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "input-group-prepend"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "input-group-text fas fa-file"
  })), /*#__PURE__*/_react.default.createElement("input", _extends({
    type: "file"
  }, sharedProps)), /*#__PURE__*/_react.default.createElement("div", {
    className: 'fileUpload' + (formContext.errors[name] ? ' is-invalid' : ''),
    onClick: function onClick(e) {
      return document.getElementById(name).click();
    }
  }, function () {
    var e = document.getElementById(name);
    return e && e.files[0] ? e.files[0].name : null;
  }())) : null, /*#__PURE__*/_react.default.createElement("div", null, formContext.errors[name] ? formContext.errors[name].message : null)));
};
/**
 * @author coder966
 * This is meant to be used internally
 */


exports.RruFormElement = RruFormElement;

var DatePicker = /*#__PURE__*/function (_React$Component) {
  _inherits(DatePicker, _React$Component);

  var _super = _createSuper(DatePicker);

  function DatePicker(props) {
    var _this;

    _classCallCheck(this, DatePicker);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function (prevProps, prevState) {
      var _this$state = _this.state,
          day = _this$state.day,
          month = _this$state.month,
          year = _this$state.year,
          hour = _this$state.hour,
          minute = _this$state.minute;

      if (_this.props.onChange) {
        if (_this.props.type === 'date' && (!prevState || prevState.day !== day || prevState.month !== month || prevState.year !== year)) {
          day = parseInt(day);
          month = parseInt(month);
          year = parseInt(year);

          if (day < 10) {
            day = '0' + day;
          }

          if (month < 10) {
            month = '0' + month;
          }

          _this.props.onChange("".concat(year, "-").concat(month, "-").concat(day));
        } else if (_this.props.type === 'time' && (!prevState || prevState.minute !== minute || prevState.hour !== hour)) {
          hour = parseInt(hour);
          minute = parseInt(minute);

          if (hour < 10) {
            hour = '0' + hour;
          }

          if (minute < 10) {
            minute = '0' + minute;
          }

          _this.props.onChange("".concat(hour, ":").concat(minute));
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "range", function (s, e) {
      return Array(e - s + 1).fill(s).map(function (x, y) {
        return x + y;
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getDays", function () {
      if (_this.props.isHijri) {
        return _this.daysH;
      } else {
        var month = parseInt(_this.state.month);

        if (month === 2) {
          var year = parseInt(_this.state.year);
          var isLeapYear = year % 4 == 0 && year % 100 != 0 || year % 400 == 0;
          return isLeapYear ? _this.daysG29 : _this.daysG28;
        } else {
          return [1, 3, 5, 7, 8, 10, 12].includes(month) ? _this.daysG31 : _this.daysG30;
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "getMonths", function () {
      return _this.months;
    });

    _defineProperty(_assertThisInitialized(_this), "getYears", function () {
      return _this.props.isHijri ? _this.range(_this.state.minYearH, _this.state.maxYearH) : _this.range(_this.state.minYearG, _this.state.maxYearG);
    });

    _defineProperty(_assertThisInitialized(_this), "getHours", function () {
      return _this.props.clock === 24 ? _this.hours24 : _this.hours12;
    });

    _defineProperty(_assertThisInitialized(_this), "getMinutes", function () {
      return _this.minutes;
    });

    _defineProperty(_assertThisInitialized(_this), "handleField", function (event) {
      var name = event.target.name;

      if (name === 'year') {
        _this.setState({
          year: event.target.value,
          month: '1',
          day: '1'
        });
      } else if (name === 'month') {
        _this.setState({
          month: event.target.value,
          day: '1'
        });
      } else {
        _this.setState(_defineProperty({}, name, event.target.value));
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderField", function (name, valuesGetter) {
      return /*#__PURE__*/_react.default.createElement("select", {
        name: name,
        className: "custom-select",
        value: _this.state[name],
        disabled: _this.props.disabled,
        onChange: _this.handleField
      }, valuesGetter().map(function (v, i) {
        return /*#__PURE__*/_react.default.createElement("option", {
          key: v,
          value: name === 'hour' || name === 'minute' ? i : v
        }, v);
      }));
    });

    _defineProperty(_assertThisInitialized(_this), "render", function () {
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _this.props.type === 'date' ? _this.props.reverseDisplayOrder ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _this.renderField('day', _this.getDays), _this.renderField('month', _this.getMonths), _this.renderField('year', _this.getYears)) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _this.renderField('year', _this.getYears), _this.renderField('month', _this.getMonths), _this.renderField('day', _this.getDays)) : _this.props.type === 'time' ? _this.props.reverseDisplayOrder ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _this.renderField('minute', _this.getMinutes), _this.renderField('hour', _this.getHours)) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _this.renderField('hour', _this.getHours), _this.renderField('minute', _this.getMinutes)) : null);
    });

    var todayH = new Intl.DateTimeFormat('en-US-u-ca-islamic', {
      day: 'numeric',
      month: 'numeric',
      year: 'numeric'
    }).format(Date.now()).replace(' AH', '').split('/');
    var todayG = new Date(); // TODO: user default value from initial values

    var defaultPartsDate = props.defaultValue ? props.defaultValue.split('-') : undefined;
    var defaultPartsTime = props.defaultValue ? props.defaultValue.split(':') : undefined;
    var currentDayH = parseInt(defaultPartsDate ? defaultPartsDate[2] : todayH[1]);
    var currentDayG = parseInt(defaultPartsDate ? defaultPartsDate[2] : todayG.getDate());
    var currentMonthH = parseInt(defaultPartsDate ? defaultPartsDate[1] : todayH[0]);
    var currentMonthG = parseInt(defaultPartsDate ? defaultPartsDate[1] : todayG.getMonth() + 1);
    var currentYearH = parseInt(defaultPartsDate ? defaultPartsDate[0] : todayH[2]);
    var currentYearG = parseInt(defaultPartsDate ? defaultPartsDate[0] : todayG.getFullYear());
    _this.state = props.isHijri ? {
      day: currentDayH,
      month: currentMonthH,
      year: currentYearH
    } : {
      day: currentDayG,
      month: currentMonthG,
      year: currentYearG
    };
    var maxYearLength = _this.props.maxYearLength || 100;
    _this.state.minYearH = _this.props.isFuture ? currentYearH : currentYearH - maxYearLength;
    _this.state.minYearG = _this.props.isFuture ? currentYearG : currentYearG - maxYearLength;
    _this.state.maxYearH = _this.props.isPast ? currentYearH : currentYearH + maxYearLength;
    _this.state.maxYearG = _this.props.isPast ? currentYearG : currentYearG + maxYearLength;
    _this.state.hour = defaultPartsTime ? parseInt(defaultPartsTime[0]) : 0;
    _this.state.minute = defaultPartsTime ? parseInt(defaultPartsTime[1]) : 0; // for performance

    _this.daysH = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28', '29', '30'];
    _this.daysG28 = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28'];
    _this.daysG29 = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28', '29'];
    _this.daysG30 = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28', '29', '30'];
    _this.daysG31 = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28', '29', '30', '31'];
    _this.months = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'];
    _this.hours24 = ['00', '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23'];
    _this.hours12 = ['12 AM', '01 AM', '02 AM', '03 AM', '04 AM', '05 AM', '06 AM', '07 AM', '08 AM', '09 AM', '10 AM', '11 AM', '12 PM', '01 PM', '02 PM', '03 PM', '04 PM', '05 PM', '06 PM', '07 PM', '08 PM', '09 PM', '10 PM', '11 PM'];
    _this.minutes = ['00', '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28', '29', '30', '31', '32', '33', '34', '35', '36', '37', '38', '39', '40', '41', '42', '43', '44', '45', '46', '47', '48', '49', '50', '51', '52', '53', '54', '55', '56', '57', '58', '59']; // because controlled fields need to call setValue for the initial value

    _this.componentDidUpdate(props, null);

    return _this;
  }

  return DatePicker;
}(_react.default.Component);